//+------------------------------------------------------------------+
//|                                                Dolly_Expert.mq4  |
//|                                              Lopatin Alex  2006 |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright "Lopatin Alex 2006"
#property link      "http://www.fxprog.ru"

#define ORDER_ID 212598
extern double TakeProfit = 20;
extern double n = 20;
extern double Lots = 0.1;
extern string TimeOrders1  = "09:00";
extern string TimeOrders2  = "17:00";
extern string Order_Comment="Dolly Expert";
extern int UrovenBezubytka =30;

datetime prev_time=0;

void DeleteStopOrders()
{
   int order_type,tf=Period();
   string symb=Symbol();
   for(int i=0;i<OrdersTotal();i++)
   {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==symb&&OrderMagicNumber()==(ORDER_ID+tf))
      {
         order_type=OrderType();
         if(order_type==OP_BUYSTOP||order_type==OP_SELLSTOP)
            OrderDelete(OrderTicket());
      }
   }
}
void Bezubytok()
{
   double dP = UrovenBezubytka*Point; 
   for(int i=0;i<OrdersTotal();i++)
   {
        OrderSelect(i, SELECT_BY_POS, MODE_TRADES);
        
        if(OrderMagicNumber()==(ORDER_ID+Period())&&OrderSymbol()==Symbol())
        {
            if(OrderType()==OP_BUY)
            {
               if(UrovenBezubytka>(Bid-Ask)&&OrderStopLoss()<OrderOpenPrice() && (Bid-OrderOpenPrice())>=dP)
               {
                    OrderModify(OrderTicket(),OrderOpenPrice(),Bid-dP,OrderTakeProfit(),0,Yellow);
               }
                
            }
            if(OrderType()==OP_SELL)
            {                                    
                if(UrovenBezubytka>(Bid-Ask)&&(OrderStopLoss()<Point || OrderStopLoss()>OrderOpenPrice()) && (OrderOpenPrice()-Ask)>=dP )
                {
                        OrderModify(OrderTicket(),OrderOpenPrice(),Ask+dP,OrderTakeProfit(),0,Red);
                }
            }
        }
   }
   }
int start()
  {
  Bezubytok();
   if(prev_time==Time[0])//   
           return(0);
   prev_time=Time[0];
   int ticket;
   double stoploss=NormalizeDouble(iCustom(NULL,0,"Dolly Graphics(M)",0,0),Digits);
   double sell_stop=NormalizeDouble(iCustom(NULL,0,"Dolly Graphics(M)",1,0),Digits);
   double buy_stop=NormalizeDouble(iCustom(NULL,0,"Dolly Graphics(M)",2,0),Digits);
   if(TimeToStr(CurTime(), TIME_MINUTES)==TimeOrders1||TimeToStr(CurTime(), TIME_MINUTES)==TimeOrders2&&Close[0]<buy_stop&&Close[0]>sell_stop)
   {
       DeleteStopOrders();
       ticket=OrderSend(Symbol(),OP_SELLSTOP,Lots,sell_stop,3,stoploss+n*Point,sell_stop-TakeProfit*Point,Order_Comment,ORDER_ID+Period(),0,Red);
       if(ticket<=0)
            Print("Error opening SELLSTOP order : ",GetLastError());
       ticket=OrderSend(Symbol(),OP_BUYSTOP,Lots,buy_stop,3,stoploss-n*Point,buy_stop+TakeProfit*Point,Order_Comment,ORDER_ID+Period(),0,Yellow);
       if(ticket<=0)
            Print("Error opening BUYSTOP order : ",GetLastError());
   }
   return(0);
  }